Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 475)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 476)
@@ -764,40 +969,13 @@
  * This will start the registration process, if registration is configured.
  */
-pj_status_t pjsua_start(void)
+PJ_DEF(pj_status_t) pjsua_start(void)
 {
     int i;  /* Must be signed */
-    pjsip_transport *udp_transport;
     pj_status_t status = PJ_SUCCESS;
 
-    /*
-     * Init media subsystem (codecs, conference bridge, et all).
-     */
-    status = init_media();
-    if (status != PJ_SUCCESS)
-	return status;
-
-    /* Init sockets (STUN etc): */
-    for (i=0; i<(int)pjsua.max_calls; ++i) {
-	status = init_sockets(i==0, &pjsua.calls[i].skinfo);
-	if (status == PJ_SUCCESS)
-	    status = pjmedia_transport_udp_attach(pjsua.med_endpt, NULL,
-						  &pjsua.calls[i].skinfo,
-						  &pjsua.calls[i].med_tp);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "init_sockets() has returned error", 
-			 status);
-	    --i;
-	    if (i >= 0)
-		pj_sock_close(pjsua.sip_sock);
-	    while (i >= 0) {
-		pjmedia_transport_udp_close(pjsua.calls[i].med_tp);
-	    }
-	    return status;
-	}
-    }
 
     /* Add UDP transport: */
-
-    {
+    if (pjsua.sip_sock > 0) {
+
 	/* Init the published name for the transport.
          * Depending whether STUN is used, this may be the STUN mapped
@@ -806,7 +984,6 @@
 	pjsip_host_port addr_name;
 
-	addr_name.host.ptr = pj_inet_ntoa(pjsua.sip_sock_name.sin_addr);
-	addr_name.host.slen = pj_ansi_strlen(addr_name.host.ptr);
-	addr_name.port = pj_ntohs(pjsua.sip_sock_name.sin_port);
+	addr_name.host = pjsua.config.sip_host;
+	addr_name.port = pjsua.config.sip_port;
 
 	/* Create UDP transport from previously created UDP socket: */
@@ -814,5 +991,5 @@
 	status = pjsip_udp_transport_attach( pjsua.endpt, pjsua.sip_sock,
 					     &addr_name, 1, 
-					     &udp_transport);
+					     NULL);
 	if (status != PJ_SUCCESS) {
 	    pjsua_perror(THIS_FILE, "Unable to start UDP transport", 
@@ -822,7 +999,28 @@
     }
 
-    /* Initialize Contact URI, if one is not specified: */
-    for (i=0; i<pjsua.acc_cnt; ++i) {
-
+    /* The last account is default account to be used when nothing match 
+     * any configured accounts.
+     */
+    {
+	char buf[80];
+	pj_str_t tmp;
+	pjsua_acc_config *acc_cfg = 
+	    &pjsua.config.acc_config[pjsua.config.acc_cnt];
+
+	tmp.ptr = buf;
+	tmp.slen = pj_ansi_sprintf(tmp.ptr, "<sip:%s:%d>", 
+				   pjsua.config.sip_host.ptr,
+				   pjsua.config.sip_port);
+
+	pj_strdup_with_null( pjsua.pool, &acc_cfg->id, &tmp);
+	acc_cfg->contact = acc_cfg->id;
+    }
+    
+
+    /* Initialize accounts: */
+    for (i=0; i<(int)pjsua.config.acc_cnt; ++i) {
+
+	pjsua_acc_config *acc_cfg = &pjsua.config.acc_config[i];
+	pjsua_acc *acc = &pjsua.acc[i];
 	pjsip_uri *uri;
 	pjsip_sip_uri *sip_uri;
@@ -830,6 +1028,6 @@
 	/* Need to parse local_uri to get the elements: */
 
-	uri = pjsip_parse_uri(pjsua.pool, pjsua.acc[i].local_uri.ptr,
-			      pjsua.acc[i].local_uri.slen, 0);
+	uri = pjsip_parse_uri(pjsua.pool, acc_cfg->id.ptr,
+			      acc_cfg->id.slen, 0);
 	if (uri == NULL) {
 	    pjsua_perror(THIS_FILE, "Invalid local URI", 
@@ -853,12 +1051,17 @@
 	sip_uri = (pjsip_sip_uri*) pjsip_uri_get_uri(uri);
 
-	pjsua.acc[i].user_part = sip_uri->user;
-	pjsua.acc[i].host_part = sip_uri->host;
-
-	if (pjsua.acc[i].contact_uri.slen == 0 && 
-	    pjsua.acc[i].local_uri.slen) 
-	{
+	acc->user_part = sip_uri->user;
+	acc->host_part = sip_uri->host;
+
+	/* Build Contact header */
+
+	if (acc_cfg->contact.slen == 0)  {
 	    char contact[128];
+	    const char *addr;
+	    int port;
 	    int len;
+
+	    addr = pjsua.config.sip_host.ptr;
+	    port = pjsua.config.sip_port;
 
 	    /* The local Contact is the username@ip-addr, where
@@ -874,10 +1077,8 @@
 		/* With the user part. */
 		len = pj_ansi_snprintf(contact, sizeof(contact),
-				  "<sip:%.*s@%.*s:%d>",
+				  "<sip:%.*s@%s:%d>",
 				  (int)sip_uri->user.slen,
 				  sip_uri->user.ptr,
-				  (int)udp_transport->local_name.host.slen,
-				  udp_transport->local_name.host.ptr,
-				  udp_transport->local_name.port);
+				  addr, port);
 	    } else {
 
@@ -885,8 +1086,6 @@
 
 		len = pj_ansi_snprintf(contact, sizeof(contact),
-				  "<sip:%.*s:%d>",
-				  (int)udp_transport->local_name.host.slen,
-				  udp_transport->local_name.host.ptr,
-				  udp_transport->local_name.port);
+				  "<sip:%s:%d>",
+				  addr, port);
 	    }
 
@@ -898,36 +1097,37 @@
 	    /* Duplicate Contact uri. */
 
-	    pj_strdup2(pjsua.pool, &pjsua.acc[i].contact_uri, contact);
-
-	}
-    }
-
-    /* If outbound_proxy is specified, put it in the route_set: */
-
-    if (pjsua.outbound_proxy.slen) {
-
-	pjsip_route_hdr *route;
-	const pj_str_t hname = { "Route", 5 };
-	int parsed_len;
-
-	route = pjsip_parse_hdr( pjsua.pool, &hname, 
-				 pjsua.outbound_proxy.ptr, 
-				 pjsua.outbound_proxy.slen,
-				   &parsed_len);
-	if (route == NULL) {
-	    pjsua_perror(THIS_FILE, "Invalid outbound proxy URL", 
-			 PJSIP_EINVALIDURI);
-	    return PJSIP_EINVALIDURI;
-	}
-
-	for (i=0; i<pjsua.acc_cnt; ++i) {
-	    pj_list_push_front(&pjsua.acc[i].route_set, route);
-	}
-    }
+	    pj_strdup2(pjsua.pool, &acc_cfg->contact, contact);
+
+	}
+
+
+	/* Build route-set for this account */
+	if (pjsua.config.outbound_proxy.slen) {
+	    pj_str_t hname = { "Route", 5};
+	    pjsip_route_hdr *r;
+	    pj_str_t tmp;
+
+	    pj_strdup_with_null(pjsua.pool, &tmp, &pjsua.config.outbound_proxy);
+	    r = pjsip_parse_hdr(pjsua.pool, &hname, tmp.ptr, tmp.slen, NULL);
+	    pj_list_push_back(&acc->route_set, r);
+	}
+
+	if (acc_cfg->proxy.slen) {
+	    pj_str_t hname = { "Route", 5};
+	    pjsip_route_hdr *r;
+	    pj_str_t tmp;
+
+	    pj_strdup_with_null(pjsua.pool, &tmp, &acc_cfg->proxy);
+	    r = pjsip_parse_hdr(pjsua.pool, &hname, tmp.ptr, tmp.slen, NULL);
+	    pj_list_push_back(&acc->route_set, r);
+	}
+    }
+
+
 
 
     /* Create worker thread(s), if required: */
 
-    for (i=0; i<pjsua.thread_cnt; ++i) {
+    for (i=0; i<(int)pjsua.config.thread_cnt; ++i) {
 	status = pj_thread_create( pjsua.pool, "pjsua", &pjsua_poll,
 				   NULL, 0, 0, &pjsua.threads[i]);
@@ -945,5 +1145,5 @@
 
     /* Create client registration session: */
-    for (i=0; i<pjsua.acc_cnt; ++i) {
+    for (i=0; i<(int)pjsua.config.acc_cnt; ++i) {
 	status = pjsua_regc_init(i);
 	if (status != PJ_SUCCESS)
@@ -956,4 +1156,10 @@
     }
 
+
+    /* Init buddies */
+    for (i=0; i<(int)pjsua.config.buddy_cnt; ++i) {
+	pjsua.buddies[i].uri = pjsua.config.buddy_uri[i];
+    }
+    pjsua.buddy_cnt = pjsua.config.buddy_cnt;
 
     /* Find account for outgoing preence subscription */
@@ -987,5 +1193,5 @@
  * Destroy pjsua.
  */
-pj_status_t pjsua_destroy(void)
+PJ_DEF(pj_status_t) pjsua_destroy(void)
 {
     int i;  /* Must be signed */
@@ -1001,5 +1207,5 @@
 
     /* Unregister, if required: */
-    for (i=0; i<pjsua.acc_cnt; ++i) {
+    for (i=0; i<(int)pjsua.config.acc_cnt; ++i) {
 	if (pjsua.acc[i].regc) {
 	    pjsua_regc_update(i, 0);
@@ -1008,5 +1214,5 @@
 
     /* Wait worker threads to quit: */
-    for (i=0; i<pjsua.thread_cnt; ++i) {
+    for (i=0; i<(int)pjsua.config.thread_cnt; ++i) {
 	
 	if (pjsua.threads[i]) {
@@ -1030,8 +1236,4 @@
 	pjmedia_port_destroy(pjsua.file_port);
 
-    /* Destroy null port. */
-    if (pjsua.null_port)
-	pjmedia_port_destroy(pjsua.null_port);
-
 
     /* Shutdown all codecs: */
@@ -1054,5 +1256,5 @@
 
     /* Close transports */
-    for (i=0; i<pjsua.call_cnt; ++i) {
+    for (i=0; pjsua.config.start_rtp_port && i<(int)pjsua.config.max_calls; ++i) {
 	pjmedia_transport_udp_close(pjsua.calls[i].med_tp);
     }
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 475)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 476)
@@ -153,5 +153,6 @@
 	text.slen = rdata->msg_info.msg->body->len;
 
-	pjsua_ui_on_pager(call_index, from, to, &text);
+	if (pjsua.cb.on_pager)
+	    (*pjsua.cb.on_pager)(call_index, from, to, &text);
 
     } else {
@@ -170,5 +171,6 @@
 	}
 
-	pjsua_ui_on_typing(call_index, from, to, is_typing);
+	if (pjsua.cb.on_typing)
+	    (*pjsua.cb.on_typing)(call_index, from, to, is_typing);
     }
 
@@ -270,6 +272,6 @@
  * Send IM outside dialog.
  */
-pj_status_t pjsua_im_send(int acc_index, const char *dst_uri, 
-			  const char *str)
+PJ_DEF(pj_status_t) pjsua_im_send(int acc_index, const char *dst_uri, 
+				  const char *str)
 {
     pjsip_tx_data *tdata;
@@ -282,7 +284,8 @@
 
     /* Create request. */
-    status = pjsip_endpt_create_request( pjsua.endpt, &pjsip_message_method,
-					 &dst, &pjsua.acc[acc_index].local_uri,
-					 &dst, NULL, NULL, -1, NULL, &tdata);
+    status = pjsip_endpt_create_request(pjsua.endpt, &pjsip_message_method,
+					&dst, 
+					&pjsua.config.acc_config[acc_index].id,
+					&dst, NULL, NULL, -1, NULL, &tdata);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Unable to create request", status);
@@ -296,7 +299,7 @@
     /* Add contact. */
     pjsip_msg_add_hdr( tdata->msg, (pjsip_hdr*)
-		       pjsip_generic_string_hdr_create(tdata->pool, 
-						       &STR_CONTACT,
-						       &pjsua.acc[acc_index].contact_uri));
+	pjsip_generic_string_hdr_create(tdata->pool, 
+					&STR_CONTACT,
+					&pjsua.config.acc_config[acc_index].contact));
 
     /* Duplicate text.
@@ -331,6 +334,6 @@
  * Send typing indication outside dialog.
  */
-pj_status_t pjsua_im_typing(int acc_index, const char *dst_uri, 
-			    pj_bool_t is_typing)
+PJ_DEF(pj_status_t) pjsua_im_typing(int acc_index, const char *dst_uri, 
+				    pj_bool_t is_typing)
 {
     const pj_str_t dst = pj_str((char*)dst_uri);
@@ -340,5 +343,6 @@
     /* Create request. */
     status = pjsip_endpt_create_request( pjsua.endpt, &pjsip_message_method,
-					 &dst, &pjsua.acc[acc_index].local_uri,
+					 &dst, 
+					 &pjsua.config.acc_config[acc_index].id,
 					 &dst, NULL, NULL, -1, NULL, &tdata);
     if (status != PJ_SUCCESS) {
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_imp.h
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_imp.h	(revision 476)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_imp.h	(revision 476)
@@ -0,0 +1,95 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJSUA_IMP_H__
+#define __PJSUA_IMP_H__
+
+
+
+/**
+ * Find account for incoming request.
+ */
+int pjsua_find_account_for_incoming(pjsip_rx_data *rdata);
+
+
+/**
+ * Find account for outgoing request.
+ */
+int pjsua_find_account_for_outgoing(const pj_str_t *url);
+
+
+/**
+ * Init pjsua call module.
+ */
+pj_status_t pjsua_call_init(void);
+
+
+/**
+ * Handle incoming invite request.
+ */
+pj_bool_t pjsua_call_on_incoming(pjsip_rx_data *rdata);
+
+
+/**
+ * Initialize client registration session.
+ *
+ * @param app_callback	Optional callback
+ */
+pj_status_t pjsua_regc_init(int acc_index);
+
+
+/**
+ * Init presence.
+ */
+pj_status_t pjsua_pres_init();
+
+
+/**
+ * Terminate all subscriptions
+ */
+void pjsua_pres_shutdown(void);
+
+/**
+ * Init IM module handler to handle incoming MESSAGE outside dialog.
+ */
+pj_status_t pjsua_im_init();
+
+/**
+ * Create Accept header for MESSAGE.
+ */
+pjsip_accept_hdr* pjsua_im_create_accept(pj_pool_t *pool);
+
+/**
+ * Private: check if we can accept the message.
+ *	    If not, then p_accept header will be filled with a valid
+ *	    Accept header.
+ */
+pj_bool_t pjsua_im_accept_pager(pjsip_rx_data *rdata,
+				pjsip_accept_hdr **p_accept_hdr);
+
+/**
+ * Private: process pager message.
+ *	    This may trigger pjsua_ui_on_pager() or pjsua_ui_on_typing().
+ */
+void pjsua_im_process_pager(int call_id, const pj_str_t *from,
+			    const pj_str_t *to, pjsip_rx_data *rdata);
+
+
+
+#endif	/* __PJSUA_IMP_H__ */
+
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 475)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 476)
@@ -18,4 +18,5 @@
  */
 #include <pjsua-lib/pjsua.h>
+#include "pjsua_imp.h"
 
 /*
@@ -81,4 +82,5 @@
 {
     int acc_index;
+    pjsua_acc_config *acc_config;
     pjsip_method *req_method = &rdata->msg_info.msg->line.req.method;
     pjsua_srv_pres *uapres;
@@ -97,9 +99,10 @@
     /* Find which account for the incoming request. */
     acc_index = pjsua_find_account_for_incoming(rdata);
+    acc_config = &pjsua.config.acc_config[acc_index];
 
     /* Create UAS dialog: */
-    status = pjsip_dlg_create_uas( pjsip_ua_instance(), rdata, 
-				   &pjsua.acc[acc_index].contact_uri, 
-				   &dlg);
+    status = pjsip_dlg_create_uas(pjsip_ua_instance(), rdata, 
+				  &acc_config->contact,
+				  &dlg);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, 
@@ -307,4 +310,5 @@
 {
     int acc_index;
+    pjsua_acc_config *acc_config;
     pjsip_dialog *dlg;
     pjsip_tx_data *tdata;
@@ -312,8 +316,9 @@
 
     acc_index = pjsua.buddies[index].acc_index;
+    acc_config = &pjsua.config.acc_config[acc_index];
 
     status = pjsip_dlg_create_uac( pjsip_ua_instance(), 
-				   &pjsua.acc[acc_index].local_uri,
-				   &pjsua.acc[acc_index].contact_uri,
+				   &acc_config->id,
+				   &acc_config->contact,
 				   &pjsua.buddies[index].uri,
 				   NULL, &dlg);
@@ -324,6 +329,9 @@
     }
 
-    pjsip_auth_clt_set_credentials( &dlg->auth_sess, pjsua.cred_count,
-				    pjsua.cred_info);
+    if (acc_config->cred_count) {
+	pjsip_auth_clt_set_credentials( &dlg->auth_sess, 
+					acc_config->cred_count,
+					acc_config->cred_info);
+    }
 
     status = pjsip_pres_create_uac( dlg, &pres_callback, 
@@ -427,5 +435,5 @@
  * Refresh presence
  */
-void pjsua_pres_refresh(int acc_index)
+PJ_DEF(void) pjsua_pres_refresh(int acc_index)
 {
     refresh_client_subscription();
@@ -442,5 +450,5 @@
     int i;
 
-    for (acc_index=0; acc_index<pjsua.acc_cnt; ++acc_index) {
+    for (acc_index=0; acc_index<(int)pjsua.config.acc_cnt; ++acc_index) {
 	pjsua.acc[acc_index].online_status = 0;
     }
@@ -450,5 +458,5 @@
     }
 
-    for (acc_index=0; acc_index<pjsua.acc_cnt; ++acc_index) {
+    for (acc_index=0; acc_index<(int)pjsua.config.acc_cnt; ++acc_index) {
 	pjsua_pres_refresh(acc_index);
     }
@@ -472,5 +480,5 @@
 	int count = 0;
 
-	for (acc_index=0; acc_index < pjsua.acc_cnt; ++acc_index) {
+	for (acc_index=0; acc_index < (int)pjsua.config.acc_cnt; ++acc_index) {
 
 	    if (!pj_list_empty(&pjsua.acc[acc_index].pres_srv_list)) {
@@ -507,9 +515,9 @@
     PJ_LOG(3,(THIS_FILE, "Dumping pjsua server subscriptions:"));
 
-    for (acc_index=0; acc_index < pjsua.acc_cnt; ++acc_index) {
+    for (acc_index=0; acc_index < (int)pjsua.config.acc_cnt; ++acc_index) {
 
 	PJ_LOG(3,(THIS_FILE, "  %.*s",
-		  (int)pjsua.acc[acc_index].local_uri.slen,
-		  pjsua.acc[acc_index].local_uri.ptr));
+		  (int)pjsua.config.acc_config[acc_index].id.slen,
+		  pjsua.config.acc_config[acc_index].id.ptr));
 
 	if (pj_list_empty(&pjsua.acc[acc_index].pres_srv_list)) {
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_reg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_reg.c	(revision 475)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_reg.c	(revision 476)
@@ -60,10 +60,10 @@
 	    acc->regc = NULL;
 	    PJ_LOG(3,(THIS_FILE, "%s: unregistration success",
-		      acc->local_uri.ptr));
+		      pjsua.config.acc_config[acc->index].id.ptr));
 	} else {
 	    PJ_LOG(3, (THIS_FILE, 
 		       "%s: registration success, status=%d (%s), "
 		       "will re-register in %d seconds", 
-		       acc->local_uri.ptr,
+		       pjsua.config.acc_config[acc->index].id.ptr,
 		       param->code,
 		       pjsip_get_status_text(param->code)->ptr,
@@ -78,5 +78,6 @@
     acc->reg_last_code = param->code;
 
-    pjsua_ui_on_reg_state(acc->index);
+    if (pjsua.cb.on_reg_state)
+	(*pjsua.cb.on_reg_state)(acc->index);
 }
 
@@ -85,5 +86,5 @@
  * Update registration. If renew is false, then unregistration will be performed.
  */
-void pjsua_regc_update(int acc_index, pj_bool_t renew)
+PJ_DECL(void) pjsua_regc_update(int acc_index, pj_bool_t renew)
 {
     pj_status_t status = 0;
@@ -130,7 +131,10 @@
 pj_status_t pjsua_regc_init(int acc_index)
 {
+    pjsua_acc_config *acc_config;
     pj_status_t status;
 
-    if (pjsua.acc[acc_index].reg_uri.slen == 0) {
+    acc_config = &pjsua.config.acc_config[acc_index];
+
+    if (acc_config->reg_uri.slen == 0) {
 	PJ_LOG(3,(THIS_FILE, "Registrar URI is not specified"));
 	return PJ_SUCCESS;
@@ -152,9 +156,9 @@
 
     status = pjsip_regc_init( pjsua.acc[acc_index].regc, 
-			      &pjsua.acc[acc_index].reg_uri, 
-			      &pjsua.acc[acc_index].local_uri, 
-			      &pjsua.acc[acc_index].local_uri,
-			      1, &pjsua.acc[acc_index].contact_uri, 
-			      pjsua.acc[acc_index].reg_timeout);
+			      &acc_config->reg_uri, 
+			      &acc_config->id, 
+			      &acc_config->id,
+			      1, &acc_config->contact, 
+			      acc_config->reg_timeout);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, 
@@ -164,7 +168,9 @@
     }
 
-    pjsip_regc_set_credentials( pjsua.acc[acc_index].regc, 
-				pjsua.cred_count, 
-				pjsua.cred_info );
+    if (acc_config->cred_count) {
+	pjsip_regc_set_credentials( pjsua.acc[acc_index].regc, 
+				    acc_config->cred_count, 
+				    acc_config->cred_info );
+    }
 
     pjsip_regc_set_route_set( pjsua.acc[acc_index].regc, 
